"{ Package: 'stx:libbasic2' }"
!

!Object methodsFor:'converting'!

!! anObject
    "return a cons with the receiver as car and the argument as cdr"

    ^ Cons car:self cdr:anObject

    "
     (1 !! 2)                
     (#car !! #cdr)          
     (1 !! (2 !! (3 !! nil)))    
     (1 !! 2) !! (2 !! 3)    
    "
! !

!Object methodsFor:'dependents-st/v event simulation'!

when:eventSymbol send:selector to:anObject
    "install an ST/V-style interest forwarder.
     Here, we use the nonWeakDependencies."

    self addInterest:(InterestConverterWithParameters
                            destination:anObject 
                            selector:selector 
                            aspect:eventSymbol).

    "
     |p b|

     b := [Transcript showCR:'the point changed'].

     p := Point new.
     p whem:#foo:bar: send:#value:value: to:[:a :b | Transcript show:'foo: '; show:a; show:' bar: '; showCR:b].
     Transcript showCR:'now changing'.
     p triggerEvent:#foo:bar: withArguments:#('fooArg' 'barArg').
     p retracrtInterests.
    "
! !

